HDU 6155 Subsequence Count(矩阵 + DP + 线段树)题解

题意:01串,操作1:把l r区间的0变1,1变0;操作2:求出l r区间的子序列种数

思路:设DP[i][j]为到i为止以j结尾的种数,假设j为0,那么dp[i][0] = dp[i - 1][1] + dp[i -1][0] (0结尾新串) + dp[i - 1][0] (0结尾旧串) - dp[i - 1][0] (重复) + 1(0本身被重复时去除)。

那么可以得到转移时的矩阵

$$ \left( \begin{matrix} dp[i - 1][0] & dp[i - 1][1] & 1 \\ 0 & 0 & 0 \\ 0 & 0 & 0 \end{matrix} \right) * \left( \begin{matrix} 1 & 0 & 0 \\ 1 &1 & 0 \\ 1 & 0 & 1 \end{matrix} \right)  =  \left( \begin{matrix} dp[i][0] & dp[i][1] & 1 \\ 0 & 0 & 0 \\ 0 & 0 & 0 \end{matrix} \right) $$

那么我们只要用线段树维护连续的矩阵乘积就行了。

如果翻转,那么存在一个规律,可以打表找出,直接实现连续区间矩阵乘积的翻转。

代码:

#include<cmath>
#include<set>
#include<map>
#include<queue>
#include<cstdio>
#include<vector>
#include<cstring>
#include <iostream>
#include<algorithm>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int maxn = 1e5 + 5;
const int M = 50 + 5;
const ull seed = 131;
const int INF = 0x3f3f3f3f;
const ll MOD = 1000000007;
char str[maxn];
struct Mat{
    ll s[3][3];
    void init(){
        memset(s, 0, sizeof(s));
    }
};
Mat Mamul(Mat a, Mat b){
    Mat ret;
    ret.init();
    for(int i = 0; i < 3; i++){
        for(int j = 0; j < 3; j++){
            for(int k = 0; k < 3; k++){
                ret.s[i][j] = (ret.s[i][j] + a.s[i][k] * b.s[k][j]) % MOD;
            }
        }
    }
    return ret;
}
Mat mul[maxn << 2];
int lazy[maxn << 2];
void is(Mat &a, char s){
    if(s == ‘0‘){
        a.s[0][0] = 1, a.s[0][1] = 0, a.s[0][2] = 0;
        a.s[1][0] = 1, a.s[1][1] = 1, a.s[1][2] = 0;
        a.s[2][0] = 1, a.s[2][1] = 0, a.s[2][2] = 1;
    }
    else{
        a.s[0][0] = 1, a.s[0][1] = 1, a.s[0][2] = 0;
        a.s[1][0] = 0, a.s[1][1] = 1, a.s[1][2] = 0;
        a.s[2][0] = 0, a.s[2][1] = 1, a.s[2][2] = 1;
    }
}
void change(Mat &a){
    swap(a.s[0][0], a.s[1][1]);
    swap(a.s[1][0], a.s[0][1]);
    swap(a.s[2][0], a.s[2][1]);
}
void pushdown(int rt){
    if(lazy[rt]){
        lazy[rt << 1] ^= lazy[rt];
        lazy[rt << 1 | 1] ^= lazy[rt];
        change(mul[rt << 1]);
        change(mul[rt << 1 | 1]);
        lazy[rt] = 0;
    }
}
void pushup(int rt){
    mul[rt] = Mamul(mul[rt << 1], mul[rt << 1 | 1]);
}
void build(int l, int r, int rt){
    lazy[rt] = 0;
    if(l == r){
        is(mul[rt], str[l]);
        return;
    }
    int m = (l + r) >> 1;
    build(l, m, rt << 1);
    build(m + 1, r, rt << 1 | 1);
    pushup(rt);
}
void update(int L, int R, int l, int r, int rt){
    if(L <= l && R >= r){
        lazy[rt] ^= 1;
        change(mul[rt]);
        return;
    }
    pushdown(rt);
    int m = (l + r) >> 1;
    if(L <= m)
        update(L, R, l, m, rt << 1);
    if(R > m)
        update(L, R, m + 1, r, rt << 1 | 1);
    pushup(rt);
}
Mat query(int L, int R, int l, int r, int rt){
    if(L <= l && R >= r){
        return mul[rt];
    }
    pushdown(rt);
    int m = (l + r) >> 1;
    Mat ret;
    ret.init();
    for(int i = 0; i < 3; i++)
        ret.s[i][i] = 1;
    if(L <= m)
        ret = Mamul(ret, query(L, R, l, m, rt << 1));
    if(R > m)
        ret = Mamul(ret, query(L, R, m + 1, r, rt << 1 | 1));
    pushup(rt);
    return ret;
}
int main(){
//    Mat a, b;
//    is(a, ‘0‘), is(b, ‘1‘);
//    a = Mamul(Mamul(Mamul(a, b), b), b);
//    for(int i = 0; i < 3; i++){
//        for(int j = 0; j < 3; j++){
//            printf("%d ", a.s[i][j]);
//        }
//        puts("");
//    }
//    printf("\n\n\n\n");
//
//    is(a, ‘1‘), is(b, ‘0‘);
//    a = Mamul(Mamul(Mamul(a, b), b), b);
//    for(int i = 0; i < 3; i++){
//        for(int j = 0; j < 3; j++){
//            printf("%d ", a.s[i][j]);
//        }
//        puts("");
//    }
//    printf("\n\n\n\n");
    int T;
    scanf("%d", &T);
    while(T--){
        int n, q;
        scanf("%d%d", &n, &q);
        scanf("%s", str + 1);
        build(1, n, 1);
        while(q--){
            int op, l, r;
            scanf("%d%d%d", &op, &l, &r);
            if(op == 1){
                update(l, r, 1, n, 1);
            }
            else{
                Mat a;
                a.init();
                a.s[0][2] = 1;
                a = Mamul(a, query(l, r, 1, n, 1));
                ll ans = (a.s[0][0] + a.s[0][1]) % MOD;
                printf("%lld\n", ans);
            }
        }
    }
    return 0;
}

原文地址:https://www.cnblogs.com/KirinSB/p/11215317.html

时间: 2024-11-10 18:14:09

HDU 6155 Subsequence Count(矩阵 + DP + 线段树)题解的相关文章

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6155 Subsequence Count 矩阵快速幂

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6155 题意: 题解来自:http://www.cnblogs.com/iRedBean/p/7398272.html 先考虑dp求01串的不同子序列的个数. dp[i][j]表示用前i个字符组成的以j为结尾的01串个数. 如果第i个字符为0,则dp[i][0] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][1] = dp[i-1][1] 如果第i个字符为1,则dp[i][1

HDU 6155 Subsequence Count 线段树维护矩阵

Subsequence Count Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 256000/256000 K (Java/Others) Problem Description Given a binary string S[1,...,N] (i.e. a sequence of 0's and 1's), and Q queries on the string. There are two types of querie

hdu 6155 -&#160;Subsequence Count

话说这题比赛时候过的好少,连题都没读TOT 先考虑dp求01串的不同子序列的个数. dp[i][j]表示用前i个字符组成的以j为结尾的01串个数. 如果第i个字符为0,则dp[i][0] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][1] = dp[i-1][1] 如果第i个字符为1,则dp[i][1] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][0] = dp[i-1][0] 显然这是线性递推,我们考虑如何用矩阵表示这种递推关系. 下面分别

HDU.6155.Subsequence Count(线段树 矩阵)

题目链接 首先考虑询问[1,n]怎么做 设 f[i][0/1]表示[1,i]以0/1结尾的不同子序列个数 则\(if(A[i]) f[i][1] = f[i-1][0] + f[i-1][1] + 1 , f[i][0] = f[i-1][0]\) \(\ \ if(!A[i]) f[i][0] = f[i-1][0] + f[i-1][1] + 1 , f[i][1] = f[i-1][1]\) 很整齐,我们来写成矩阵的样子: \(f[i,0]\ f[i,1]\ 1=f[i-1,0]\ f[i

题解 HDU 3698 Let the light guide us Dp + 线段树优化

http://acm.hdu.edu.cn/showproblem.php?pid=3698 Let the light guide us Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 62768/32768 K (Java/Others) Total Submission(s): 759    Accepted Submission(s): 253 Problem Description Plain of despair was

HDU 5068 Harry And Math Teacher( 矩阵乘法 + 线段树维护 )

HDU 5068 Harry And Math Teacher( 矩阵乘法 + 线段树维护 ) 题意: 首先是这题题意理解错误,,其次是这题无法理解状态... 已经不是英文有多烂的情况了,是中文没学好啊.....大学不学语文才是真正的硬伤啊 题目意思 有一个城堡有很多层楼, 每层楼有2个门,每个门里面又有两个楼梯,可以通往上一层的两个门 问,从x层楼到y层楼有多少中方法(不能返回) 具体看图吧,,,已经不会说话了 1 #include <cstdio> 2 #include <cstri

[后缀数组+dp/AC自动机+dp+线段树] hdu 4117 GRE Words

题意: 给你N个字符串, N(1 <= N <= 2w), 所有串的长度加一起不超过30w.每个串有个值.这个值[-1000, 1000]. 问不打乱字符串顺序,从中取若干个字符串,使得前一个串是后一个串的子串,求满足前面调条件的字符串值得和最大,求这个值. 思路: 其实就是一个很明显的dp. dp[i]代表以第i个字符串结尾的最大权值. 但是就是子串这个问题怎么处理. 由于这题数据比较水可以用后缀数组处理这个问题. 将所有字符串拼接,做sa. 每次在height数组里往上和往下寻找公共前缀等

HDU 1754 I Hate It 水线段树

点击打开链接 I Hate It Time Limit: 9000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 37367    Accepted Submission(s): 14775 Problem Description 很多学校流行一种比较的习惯.老师们很喜欢询问,从某某到某某当中,分数最高的是多少. 这让很多学生很反感. 不管你喜不喜欢,现在需要你做的是

hdu 1394 Minimum Inversion Number(线段树)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 10853    Accepted Submission(s): 6676 Problem Description The inversion number of a given number sequence a1, a2, ..., a